package com.r3chess;

import java.util.*;
import android.app.Activity;
import android.content.res.Configuration;
import android.graphics.*;
import android.os.*;
import android.view.*;
import android.view.SurfaceHolder.Callback;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.*;

public class r3chessActivity extends Activity {
	
    Timer r3Timer = new Timer();    
    r3TimerTask r3Task = new r3TimerTask();

	r3chessBoard r3B = new r3chessBoard(this);
	r3telnet r3T = new r3telnet();
	r3fics r3F = new r3fics();
	
	String telnBuf = "";
	Handler myHd1, myHd2;
	Menu myMenu;
    EditText tfServer, tfPort, tfLogin, tfPassw, tfStartCmds, tfGrabMask, tfGrabNotMask;
    Button tfSave;
    int FicsRedrawer = 0;
    boolean Redraw = false;
    Thread thread;
    
    @Override
    public void onConfigurationChanged(Configuration newConfig) 
    {
    	// nothing
    }
    
    class ObsData
    {
    	String Game = "";
    	String History = "";
    	int smMoveNr = 0;
    	int mlistMoveNr = 0;
    }
    ObsData Obs = new ObsData();  
    
    
	// 0-Board view, 1-Telnet, 2-Fics options,
    // 3-board for Fics, 4-console while playing game, 5-board waiting for exit
	int Switch = 0;		
	
	SurfaceHolder SurfHd;
	public int TS = 0;		// Telnet status
	int tick4grab = 0;
	
	// menu
	static final int[] muItems =
		{ R.id.but1, R.id.but2, R.id.but3, R.id.but4, R.id.but5 };
	static final String[][] menucis = {
    		{"New game","Undo move","FICS","About",""},
    		{"Watch","Grab game","Options","Exit FICS","About"},
    		{"Save","","","",""},
    		{"Console","Offer draw","Resign","TakeBack",""},
    		{"To board","","","",""},
    		{"Console","","","",""}
    	};

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    // activate timer
	    r3Timer.schedule(r3Task,200,100);
	    
		// primary layout 3D board with chess engine
	    ActivateBoardView();
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
    	
	    if (keyCode == KeyEvent.KEYCODE_BACK) {

	    	if(Switch==2)
    			{
	    		ActivateTelnetView(1);		// login again
	    		return false;
    			}	    		
	    	if(Switch==4)
				{
	    		BackToActivateBoardView();	// board again
	    		return false;
				}
	    	if(Switch==5)
				{
	    		BackToActivateTelnetView();	// to console
	    		return false;
				}
	    }
	    return super.onKeyDown(keyCode, event);
	}
	
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	MenuInflater inflater = getMenuInflater();

    	// activates menu for 3D board with chess engine 
    	inflater.inflate(R.menu.menu, menu);
    	myMenu = menu;
    	SetMenuItems();
    	return true;
    } 

	//--------------------
	// all MENU items
	//--------------------
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    
    	int i = item.getItemId();
    	
    	switch( Switch )
    	{
    	case 0:		
    	{
    	// 3D board with engine
    	switch(i)
    	{
    	case R.id.but1:		// New game		
    		{
    		synchronized(r3B.lock)
    			{
    			boolean inv_was = r3B.Inverted;
    			r3B = new r3chessBoard(this);
    			r3B.Inverted = !inv_was;		// swap sides
    			RdrwBrd();
				return true;
    			}
    		}
    	case R.id.but2:		// Undo move
			{
	    	synchronized(r3B.lock)
    			{
    			r3B.DOTAKEBACK();
    			RdrwBrd();
    			return true;
				}
    		}
    	case R.id.but3:		// Switch to FICS
			{
				if( r3F.FirstTimeLoading() )
						ActivateFicsOptionsView();
				else ActivateTelnetView(1);
				
	    		return true;
    		}
    	case R.id.but4:		// About
	    	{
	    	About();
			return true;
			}
    	}
    	return false;
    	}
    	
    	case 1:		
    	{
    	// Telnet layout
    	switch(i)
    	{
    	case R.id.but1:			
		{
						// Observe game
			telnBuf+="Better use command: observe <user or game> \n"+
						"now looking for random game...\n";
			
			TS = 40;
			GetGamesListFics();
    		return true;
		}
    	case R.id.but2:			
		{
			TS = 14;			// Grab game
			telnBuf+="grabbing a game...\n";
    		return true;
		}
    	case R.id.but3:			
		{
			ActivateFicsOptionsView();
    		return true;
		}
    	case R.id.but4:			// back to Fruit		
    		{
    			TS = 99; TelnetAct2( "exit" );
    		    Switch = 0;
    			ActivateBoardView();
	    		return true;
    		}
    	case R.id.but5:			// About
    		{
				About();
				return true;
    		}
    	}
    	return false;
    	}    	
    	
    	case 2:		
    	{
    	// FICS options layout
    	switch(i)
    	{
    	case R.id.but1:			
			{
			SaveFicsOpts();
    		return true;
			}
    	}
    	return false;
    	}    	

    	case 3:		
    	{
    	// FICS board layout
    	switch(i)
    	{
    	case R.id.but1:			
			{
			BackToActivateTelnetView();
    		return true;
			}
    	case R.id.but2:			
			{
			TelnetAct2("draw");
    		return true;
			}			
		case R.id.but3:			
			{
			TelnetAct2("resign");
    		return true;
			}
    	case R.id.but4:			
			{
			TelnetAct2("takeback 2");
			//this should redraw screen
			r3B.Fics.currGMove = "";
			r3B.Fics.currGMwas = "";
    		return true;
			}			
			
    	}
    	return false;
    	}    	

    	case 4:		
    	{
    	// Console for particular game. Can return only
    	switch(i)
    	{
    	case R.id.but1:			
			{
			BackToActivateBoardView();
    		return true;
			}
    	}
    	return false;
    	}
    	
    	case 5:		
    	{
    	// After game ended, go to Console only
    	switch(i)
    	{
    	case R.id.but1:			
			{
			BackToActivateTelnetView();
    		return true;
			}
    	}
    	return false;
    	}
    	
    	}
    	
		// somehow allow force redraw board
		if(r3B.Fics.FicsGame)
			{
			RefreshFics();
			RdrwBrd();
			}
    	
    	return false;
    }
    
    void About()
    {
    	Toast.makeText(getBaseContext(), R.string.about, Toast.LENGTH_LONG).show();   	
    }
    
    void SetMenuItems()
    {
    	String[] mu = menucis[Switch];
    	if(myMenu!=null)
    	{
    	 int k, menusize;
    	 String c;
    	 for(k=0;k<muItems.length;k++)	// set titles for all items
    	 { 
    		c = mu[k];
    		menusize = myMenu.size();
    		if(menusize<=k)
    			{
    			if(c.length()>0)
    			 myMenu.add(Menu.NONE,muItems[k],k,c);
    			}
    		else
    			{
    			MenuItem t = myMenu.findItem(muItems[k]);
    			t.setTitle(c);
    			}
    	 }
    	 while((--k)>=0)			// remove empty items
    	 {
    		menusize = myMenu.size();
     		if(menusize>k)
     			{
     			c = mu[k];
     			if(c.length()==0) myMenu.removeItem( muItems[k] );
     			}
    	 }
    	}
    }
    

	@Override
    public void onDestroy() {
		if(r3T.active) r3T.CloseSocket();
        super.onDestroy();
	}
	
	// This works on Timer event
	private class r3TimerTask extends TimerTask{
		  public void run()
		  {
			  String r="";
			  if(r3T.active)	// if Telnet ok
			  {  
				  while(r3T.IsInBuffer())
				  {
					  r = r3T.ReadLn();
					  System.out.println(r);
					  telnBuf+=r;
					  MessageTelnetView();
					  TelnetAction(r.trim().replace("\r","").replace("\n",""));  					  
				  }
			  }
  
			  if( r3B.MoveIfShould() )	// if chess engine
				  RdrwBrd();
			  
			  if( r3B.Fics.FicsGame && TS==22 && ( Switch==5 || Switch==3) )
			   {
				  // Verifies chess status
				synchronized(r3B.lock)
				{
					if( r3B.FICSverifyGame() ) RdrwBrd();
				}
				if(FicsRedrawer>0) FicsRedrawer--;
				if(FicsRedrawer==0)
					{
					RdrwBrd();
					FicsRedrawer=30;
					}
			   }
			  
			  if(tick4grab>0) tick4grab--;	// ticker				
		  }
	}

	String tBUF = "";
	
	void TelnetAction(String r)
	{
		int j,i,a,b,w;
		String r2 = r.toUpperCase();
		
		// while 3d board not active but game is running on telnet
		if(TS==20 || TS==23 || TS==24 || TS==26 || TS==58 ) tBUF+=r+'\n';
		
		// Login and password...
		if(TS==0 && r.indexOf("ogin")>=0)
			{
			r3T.Send( r3F.UserLogin ); TS=1;
			}
		if(TS==1 && r.indexOf("enter")>=0 &&
				r.indexOf("server")>=0 && r.indexOf('"')>=0)
			{
			r3F.UserLogin = InPekas(r,0); TS=2;
			}
		if((TS==1 && r.indexOf("passw")>=0) || TS==2)
			{
			r3F.UserLogin = r3F.UserLogin.replace('\t',' ').trim();
			r3T.Send( r3F.Password ); TS=3;
			}
		if(TS==3 &&	(r.indexOf("fics%")>=0 ||
				(r.indexOf("logg")>=0 && r.indexOf("in")>=0) ))
			{
			for(j=0;j<100;j++)
			{
				String fcmd = r3F.getNextPartBy(';',j,r3F.StartCmds);
				if(fcmd==null) break;
				r3T.Send( fcmd );
			}		
			TS=10;
			}
		
		// Grab a game...
		// Could use Fics "seek" command, just the same idea...
		if(TS==14)
			{
			int badf=0;
			// keywords should be
			for(j=0;badf==0 && j<100;j++)
			{
				String gM = r3F.getNextPartBy(';',j,r3F.Grab.Mask);
				if(gM==null) break;
				for(badf=1,i=0;gM.length()>0 && badf==1 && i<100;i++)
					{
					String gMi = r3F.getNextPartBy('|',i,gM);				
					if(gMi==null) break;
					if(gMi.length()>0 &&
							r2.indexOf(gMi.toUpperCase())>=0) badf=0;
					}
			}
			// keywords should not
			for(j=0;badf==0 && j<100;j++)
			{
				String gNM = r3F.getNextPartBy(';',j,r3F.Grab.NotMask);
				if(gNM==null) break;
				for(i=0;gNM.length()>0 && badf==0 && i<100;i++)
					{
					String gNMi = r3F.getNextPartBy('|',i,gNM);
					if(gNMi==null) break;
					if(gNMi.length()>0 &&
							r2.indexOf(gNMi.toUpperCase())>=0) badf=1;
					}
			}
			if(badf==0)
				{
				String rp = InPekas(r,0);
				r3T.Send( rp );
				TS=15; tick4grab = 90;
				}
			}
		// Wait for acceptance after play command...
		if(TS==15)
			{
			if( ( r.indexOf("seek")>=0 && r.indexOf("not available")>=0)
					|| tick4grab==0 )
				{
				telnBuf+="grabbing next...\n";
				TS=14;
				}
			else
				{
				a=r.indexOf("{Game");
				if( a>=0 && r2.indexOf("CREATING")>=0) { tBUF = ""; TS=16; }
				}
			}
		
		if(TS==16 || TS==56)
			{
			a=r.indexOf(" vs. ");
			if(a>=0)
				{
				r3B = new r3chessBoard(this);
				r3B.Inverted = (r.indexOf(r3F.UserLogin) > a);
				String nm = r.substring(a+4);
				b=nm.indexOf(')');
				r3B.Fics.BlackUserLogin = nm.substring(0,b).trim();
				b=r.indexOf('(');
				nm = r.substring(b+1,a);
				r3B.Fics.WhiteUserLogin = nm.trim();
				r3B.Fics.FicsGame = true;
				if(TS==16) TS=20;
				if(TS==56)
					{
					TS=58;
					r3B.Fics.obsorvingMode = true;
					
					// ignoring, response sometimes is too slow and not needed 
					//TS=59; r3T.Send( "moves " + Obs.Game );
					
					}
				MessageTelnetView();
				}
			}
		if(TS==22 || TS==60)
			{
    		tBUF+=r+'\n';			
	    	synchronized(r3B.lock)
				{
	    		for(;tBUF.length()>0;)
	    			{
	    			a=tBUF.indexOf('\n');
	    			r=tBUF.substring(0,a);
	    			tBUF = tBUF.substring(a+1);
	    			TelnetDataParser(r);
	    			}
				}
			}
				
		if(TS>=40 && TS<50)
			{
			
			// Looking various requests till found something interesting
			a = r.indexOf('[');
			b = r.indexOf(']');
			if(a>0 && b>0 && r.lastIndexOf(':')>70)
			{
			if(Obs.Game.length()==0) Obs.Game = "*";
			b = a-36;
			if(r.charAt(36+b)=='[' && r.charAt(47+b)==']')	// game in list
				{
				// standard or blitz, also unrated...
				char gameType = r.charAt(38+b);
				//char gameRated = r.charAt(39+b);
				if((gameType=='s' || gameType=='b'))
					{
					String RatW = r.substring(3+b,7+b).trim();
					String RatB = r.substring(20+b,24+b).trim();
					char rW1 = RatW.charAt(0);
					char rB1 = RatB.charAt(0);
					if(rW1>'0' && rW1<='9' && rB1>'0' && rB1<='9')
					 {
						// Catch stronger players only
						int RatWi = 0;
						try{
							RatWi = Integer.parseInt(RatW);
						} catch (NumberFormatException e1) {}
						int RatBi = 0;
						try{
							RatBi = Integer.parseInt(RatB);
						} catch (NumberFormatException e2) {}
						
						if(RatWi>=2300 || RatBi>=2300)
						{
						  String tcS = r.substring(40+b,43+b).trim();
						  int tc = 999;
						  try{
								tc = Integer.parseInt(tcS);
							} catch (NumberFormatException e3) {}
						  
						  // minutes per game + seconds (ignoring here)
						  if((tc>=2 && tc<=30) || (TS>44))
						  {
							  // Look on clocks. If too short of time, ignore game
							  w = r.indexOf('-', 47+b);
							  String Wc = r.substring(48+b,w).trim();
							  String Bc = r.substring(w+1);
							  Bc = Bc.substring(0,Bc.indexOf('(')).trim();
							  w = Wc.lastIndexOf(':');
							  Wc = (w>1? Wc.substring(w-2,w):Wc.substring(0,w));
							  w = Bc.lastIndexOf(':');
							  Bc = (w>1? Bc.substring(w-2,w):Bc.substring(0,w));
							  
							  int Wm = 999;
							  try{
									Wm = Integer.parseInt(Wc.trim());
								} catch (NumberFormatException eWc) {}
  
							  int Bm = 999;
							  try{
									Bm = Integer.parseInt(Bc.trim());
								} catch (NumberFormatException eBc) {}
							  
							 int minutesLeft = Wm + Bm; 						    
							 if(Wm>0 && Bm>0 && minutesLeft>3 && minutesLeft<60)
							 {
							  
								w = r.lastIndexOf(':');
							 	String mS = r.substring(w+1).trim();
							 	int m = 999; 
							 
							  try{
								  m = Integer.parseInt(mS);
								} catch (NumberFormatException e4) {}
							  if(m<1) m = 999;
							  
							  // Look for recently started games
							  if(Obs.smMoveNr==0 || m<Obs.smMoveNr)
								{
								String ogm = r.substring(0,2+b).trim();
								if( Obs.History.indexOf('[' + ogm + ']')<0)
									{
									Obs.Game = ogm;
									Obs.smMoveNr = m;
									}
								}
							 }
						  }	
						}
						
					 }
					}
				}
			}
			else
				{
				if(r.indexOf("fics%")>=0 && Obs.Game.length()>0)
					{
					if(Obs.smMoveNr==0)
						{
						TS++;
						if(TS>46)
						{
							telnBuf+="Wrong search, trying again...\n";							
							TS=40; // strange case							
						}
						else
							{
							telnBuf+="Request " + String.valueOf(TS-39) + "...\n";
							GetGamesListFics();
							}
						}
					else
						{
						TS = 56;
						r3T.Send("observe " + Obs.Game);
						Obs.History += '[' + Obs.Game + ']';
						}
					}
				}
			}
		
		if(TS==59)	// Unfortunately this is too slow, we simply set position
			{
			if(r2.startsWith("MOVE") && Obs.mlistMoveNr==0 )
					Obs.mlistMoveNr = 1;
			else	
			{
				// Like a slow motion...
				a=r.indexOf('.');
				if(a>0 && a<10 && Obs.mlistMoveNr>0)
				{
					String cmS = r.substring(0,a).trim();
					int cm = 0;
					if(cmS.length()>0 && cmS.charAt(0)>='0' && cmS.charAt(0)<='9')
					{	
					  try{
						  cm = Integer.parseInt(cmS);
						} catch (NumberFormatException ecm) {}
					} 
					if(cm==Obs.mlistMoveNr)
						{
						String mt;
						b = r.indexOf('(',a);
						if(b>=0)
						{
							mt = r.substring(a+1,b).trim();
							if(mt.length()>0)
							{
							if( r3B.FICSmove( mt )) Redraw = true;
							
							a = r.indexOf(')');
							b = r.indexOf('(',a+1);							
							if(b>=0)
								{
								mt = r.substring(a+1,b).trim();
								if(mt.length()>0)
									{
									if( r3B.FICSmove( mt )) Redraw = true;
									}							
								}
							}
						}			
						Obs.mlistMoveNr++;
						}					
				}
			}
			}
			
		if(TS==99 && r.indexOf("ogg")>=0 && r.indexOf("out")>=0)
			{
			r3B = new r3chessBoard(this);
			TS=0;
			r3T.CloseSocket();
			}

	}
	
	// each telnet string
	void TelnetDataParser(String r)
	{
		int a,b,q;
		String ColPiece;
		
		// While playing game

		if(r.startsWith("<12>"))	// Style12 game
		{
			// Simply turn style 1, because style 12 not working here
			r3T.Send("set style 1");
			RefreshFics();
		}
		else
		{
			// Style 1 as usual textual picture
		a=r.indexOf("{Game");
		b=r.indexOf("}");
		if(a>=0 && b>0)
			{
			String w=r.substring(b+1).trim();
			r3B.Fics.InfoMess = w;
			if(w.indexOf("1-0")>=0 || w.indexOf("0-1")>=0 ||
					w.indexOf("*")>=0 || (w.indexOf("1")>=0 && w.indexOf("2")>=0 ))
				{
				r3B.GameOver=true;
				Redraw = true;
				}
			}
		// if no connection or aborted 
		if(r.indexOf("has lost")>=0 || r.indexOf("has abborted")>=0)
			{
			r3B.Fics.InfoMess += " " + r.trim();
			r3B.GameOver=true;			// Lost connections...
			Redraw = true;
			}
		
		boolean B = false;
		if(r3B.Fics.obsorvingMode)		// all moves
			{
			a=r.indexOf( " Moves :" );
			if(a>=0)
				{
				int aW = r.indexOf( "White" );
				int aB = r.indexOf( "Black" );
				if(aW>=0 || aB>=0)
					{
					r3B.C0.c0_sidemoves = (aW>=0 ? 1 : -1);
					}
				}
			B = (a>=0);
			}
		else							// only against me moves
			{	
			a=r.indexOf( (!r3B.Inverted ? "Black" : "White" ) + " Moves :" );
				
			B = (a>=0) && (!toBeMyMove());
			}
		if(B)	
			{
			// move by opponent...			
			String mg= InPekas(r.substring(a),1);
			mg=mg.substring(0,mg.indexOf('(')).trim();
			r3B.Fics.InfoMess = mg;
			if( r3B.FICSmove( mg ) ) Redraw = true;
			else r3B.Fics.InfoMess+="...";
			}
    	
    	a=r.indexOf("Clock :" );
		if(a>0)
		{
			String cl = r.substring(a+7).trim();
			if(r.indexOf("White")>0) r3B.Fics.WhiteClock = cl;
			if(r.indexOf("Black")>0) r3B.Fics.BlackClock = cl;
		}
		
		boolean m_b = false;
		if(r.startsWith("fics%"))
		{
			if(r.length()>8)
				{
				String fm = r.replace('\n', ' ');
				fm = fm.replace("fics%"," ").trim();
				if(fm.length()>0) r3B.AddFicsM3(fm);
					{
						r3B.AddFicsM3(fm);	
						Redraw = true;
						m_b = true;
					}
				}	
			if(Redraw) RdrwBrd();		
		}
		
		if((!m_b) && r.indexOf("vs.")<0 &&  r.indexOf("seek")<0 &&
			( r.indexOf(r3B.Fics.WhiteUserLogin)>=0 ||
			  r.indexOf(r3B.Fics.BlackUserLogin)>=0 ||
			  r.indexOf("tells")>=0 ||
			  r.indexOf("says")>=0 || r.indexOf("you")>=0 ||
			  r.indexOf("draw")>=0 ||
			  r.indexOf("resign")>=0) ||
			  r.indexOf("take")>=0 )
			{
				r3B.AddFicsM3(r);	
				Redraw = true;
			}
			
    	a=r.indexOf("Strength :" );
		if(a>0)
		{
			String stn= r.substring(a+10).trim();
			if(r.indexOf("White")>0) r3B.Fics.WhiteStrength = stn;
			if(r.indexOf("Black")>0) r3B.Fics.BlackStrength = stn;
		}
		
		a=r.indexOf("Move # :");
		if(a>=0)
		{
			r3B.Fics.currGMove = r.substring(a+8);
			Redraw = true;
		}
		
		a=r.indexOf("|");		// pieces on board for drawing
		if(a>0)
		{
			int Vert = Integer.parseInt(r.substring(0,a).trim());
			for(q=0;q<8;q++)
			{
				int pt = a+ (q<<2)+2;
				boolean black = (r.charAt(pt)=='*');
				char piece = r.charAt(pt+(black?1:0));
				if(piece=='P') piece='p';
				ColPiece = ( piece==' ' ? null : (black?"b":"w")+piece );
				int vt = Vert-1;
				int hz =(r3B.Inverted && (!r3B.Fics.obsorvingMode) ? 7-q : q);
				r3B.Fics.Board[vt][hz]=ColPiece;
				if(r3B.Fics.obsorvingMode)		// make position current
				{
					String atSq="" + (char)('a'+hz)+ (char)('1'+vt);
					if(ColPiece == null) r3B.C0.c0_clear_at(atSq);
					else r3B.C0.c0_add_piece(ColPiece+atSq);
				}
			}
		}
		}
		
	}
	
	boolean toBeMyMove()
	{
		return (r3B.Inverted == (r3B.C0.c0_sidemoves<0));
	}
	
	void TelnetAct2(String r)
	{
		if(TS>9)
			{
			r3T.Send(r);
			if(r.startsWith("follow")) TS=56;
			if(r.startsWith("observe")) TS=56;
			}
	}

	void MessageTelnetView()
	{
		Message message = myHd1.obtainMessage();	// force somehow
		myHd1.sendMessage(message);
	}
	
	//--------------------
	// Telnet layout activation
	//--------------------
	void ActivateTelnetView(int NewSckt)
	{
	    setContentView(R.layout.r3telnet);
	    Switch = (NewSckt==1 ? 1 : (r3B.GameOver ? 1 : 4));
    	SetMenuItems();
    	
    	final EditText tCmd = (EditText) findViewById( R.id.tTelCmd );
		final EditText tOutp = (EditText) findViewById( R.id.tTelnet );
	
    	if(NewSckt==1)
    		{
    		TS = 0;
    		r3F.Get_Options();
    	
    		telnBuf+="Starting telnet session,\n"+
    			"(options in menu)...\n";
    	
    		r3T.ServerName = r3F.Server;
    		try{
    			r3T.Port = Integer.valueOf( r3F.Port );
    			}
    		catch (NumberFormatException N)
    		{
    			r3T.Port = 5000;
    		}
    		
    		if(thread==null)
    		{
    		thread = new Thread() {
    		    @Override
    		    public void run() {
    		        try {
    		            sleep(2000);
    		            r3T.CreateSocket();
    		            }
    		        catch (InterruptedException e) {
    		            e.printStackTrace();
    		        }
    		    }
    		};
    		
    		
    		};

    		thread.start();
    		
    		}
    	
	    myHd1 = new Handler() 
	    {
	        public void handleMessage(android.os.Message msg)   
	        {
            	String tcmd = tCmd.getText().toString();

            	if(TS==23)		// console for this game
    				{
        			tOutp.setText("");
        			TS=24;
    				}
           	
            	if(tcmd.length()==0 && telnBuf.length()>0)
	        		{
            		
            		String c=tOutp.getText().toString();
                	if(TS>9 && c.length()>2000)	// cut some if too long...
                	{
                		tOutp.setText("");
                	}                	
            		
	        		tOutp.append( telnBuf );
	        		telnBuf="";
	        		tCmd.requestFocusFromTouch();
	        		}
            	
        		if(TS==20)
    				{
        			Switch = 3;
        			ActivateBoardView();	// Otherwise can't switch
        			TS=26;
    				}
        		if(TS==58)
    				{
        			Switch = 5;
        			ActivateBoardView();	// Otherwise can't switch
        			TS=60;
    				}
	        	
	        }; 
	    };

	    tCmd.setOnKeyListener(new OnKeyListener() {
	            public boolean onKey(View v, int keyCode, KeyEvent event) {
	                // If the event is a key-down event on the "enter" button
	                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
	                    (keyCode == KeyEvent.KEYCODE_ENTER)) {
	                  // Perform action on key press
	                	String tcmd = tCmd.getText().toString().trim();	
	                	
	                	if(tcmd.length()>0)
	                		{
	                		TelnetAct2( tcmd );
	                		}
	                	else
	                		{
	                		if(Switch==4) BackToActivateBoardView();
	                		}
                		tCmd.setText("");
                		tCmd.requestFocusFromTouch();
	                  return true;
	                }
	                return false;
	            }
	        });
	 }
	
	//--------------------
	// Telnet layout activation
	//--------------------
	void BackToActivateTelnetView()
	{
		if(TS>50)
			{
			r3B.GameOver = true;
			r3T.Send("unobserve");
			r3T.Send("unfollow");
			TS = 62;
			}
		else
			{
	    	if(!r3B.GameOver) telnBuf+="Use SAY to chat, or other commands...\n";			
			TS = 23;
			}
		ActivateTelnetView(0);
    	
	}

	//--------------------
	// FICS options layout activation
	//--------------------
    
	void ActivateFicsOptionsView()
	{
	    if(TS>0) { TS = 99; TelnetAct2( "exit" ); }
		r3F.Get_Options();
	    setContentView(R.layout.r3fics);
	    tfServer = (EditText) findViewById( R.id.fServer );
	    tfPort = (EditText) findViewById( R.id.fPort );
	    tfLogin = (EditText) findViewById( R.id.fLogin );
	    tfPassw = (EditText) findViewById( R.id.fPassw );
	    tfSave = (Button) findViewById( R.id.tSave );
	    tfStartCmds = (EditText) findViewById( R.id.fStartCmds );
	    tfGrabMask = (EditText) findViewById( R.id.fGrabMask );
	    tfGrabNotMask = (EditText) findViewById( R.id.fGrabNotMask );

	    tfServer.setText(r3F.Server);
	    tfPort.setText(r3F.Port);   
	    tfLogin.setText(r3F.UserLogin);
	    tfPassw.setText(r3F.Password);
	    tfStartCmds.setText(r3F.StartCmds.replace(';', '\n'));
	    tfGrabMask.setText(r3F.Grab.Mask.replace(';', '\n'));
	    tfGrabNotMask.setText(r3F.Grab.NotMask.replace(';', '\n'));
	    
	    tfSave.setOnClickListener( new OnClickListener() {
			@Override
			public void onClick(View v) {
				SaveFicsOpts();
			}
	    });
	    

	    Switch = 2;
    	SetMenuItems();
 	}
	
	void SaveFicsOpts()
	{
    	r3F.Server = tfServer.getText().toString();
    	r3F.Port = tfPort.getText().toString();
    	r3F.UserLogin = tfLogin.getText().toString();
    	r3F.Password = tfPassw.getText().toString();
    	r3F.StartCmds = tfStartCmds.getText().toString();
    	r3F.Grab.Mask = tfGrabMask.getText().toString();
    	r3F.Grab.NotMask = tfGrabNotMask.getText().toString();
    	r3F.Save_Options();
    	ActivateTelnetView(1);		// login again
	}

	//--------------------
	// 3D board activation
	//--------------------
	void ActivateBoardView()
	{
	    setContentView(R.layout.main);
    	SetMenuItems();
    	
		if(TS==62)
			{
			r3B = new r3chessBoard(this);
			RdrwBrd();
			}

	    SurfaceView surface = (SurfaceView) findViewById(R.id.Surf1);
	    surface.setOnTouchListener(new View.OnTouchListener() {
	        @Override
	        public boolean onTouch(View v, MotionEvent event) {
	            if (event.getAction() == MotionEvent.ACTION_DOWN){
	                r3B.mousePressAt(event.getX(),event.getY());
	                RdrwBrd();
	            }
	            return true;
	        }
	    });
	    
	    surface.getHolder().addCallback(new Callback() {

	        @Override
	        public void surfaceCreated(SurfaceHolder holder) {
	            // Do some drawing when surface is ready
	        	SurfHd = holder;
	        	RdrwBrd();
	        }

	        @Override
	        public void surfaceDestroyed(SurfaceHolder holder) {
	        }

	        @Override
	        public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
	        	RdrwBrd();
	        }
	        
	    });

	    
	    myHd2 = new Handler() 
	    {
	        public void handleMessage(android.os.Message msg)   
	        {
	        	if(SurfHd!=null)
	        		{
	        		Canvas canvas = SurfHd.lockCanvas();            
	        		if(canvas!=null)
	        			{
	        			r3B.Draw(canvas, SurfHd);
	        			
	        			SurfHd.unlockCanvasAndPost(canvas);
	        			
	        			if(TS==26)
	        				{
	        				TS=22; RefreshFics(); RdrwBrd();
	        				}
	        			
	        			if(TS<50 && r3B.Fics.FicsGame && r3B.GameOver)
	        				{
	        				Switch=5;
	        				SetMenuItems(); 
	        				}

	        			}
	        		}
	        }; 
	    };
	    
	
	}
	
	// To return from console to board
	void BackToActivateBoardView()
		{
		if(r3B.GameOver) TS=10;
		else TS=20;
		MessageTelnetView();
		}
	
	// Messaging allows android to get focus and redraw canvas 
	void RdrwBrd()
	{
		Message message = myHd2.obtainMessage();
		myHd2.sendMessage(message);		
	}
	
	// this refreshes FICS data
	void RefreshFics()
	{
		if(Switch==3 || Switch==5 || (TS>=20 && TS<=29) ) r3T.Send("refresh");
	}
	
	// this requests FICS standard chess games
	void GetGamesListFics()
	{
		r3T.Send("games " + '/' + (TS==40 || ((TS&1)>0) ? "s" : "b" ) );
	    Obs.Game = "";
	    Obs.smMoveNr = 0;
	    Obs.mlistMoveNr = 0;
	}
	
	
	// string inside ""
	String InPekas(String S, int pekatype)
	{
	String s2="";
	char peka = (char)(pekatype==0 ? 34 : 39);	// " or '
	int a = S.indexOf(peka);
	if(a>=0)
		{
		s2 = S.substring(a+1);
		a = s2.indexOf(peka);
		if(a==0) s2="";
		else if(a>0) s2=s2.substring(0,a);
		}
	return s2;
	}
}