package com.r3chess;

import android.content.Context;

// FICS interface options

public class r3fics {

	public String Server;
	public String Port;
	public String UserLogin;
	public String Password;
	public String StartCmds;
	
	public class GrabData {
		public String Mask;
		public String NotMask;
	}
	public GrabData Grab = new GrabData();	
	
	String FicsOpt = "ficsopt.txt";
	filefunc filefunc_ = new filefunc();
	
	private Context context()
	{ return r3chess.getAppContext(); }
	
	public void Set_defaults()
	{
		Server = "freechess.org";
		Port = "5000";
		UserLogin = "guest";
		Password = "";
		StartCmds = "";
		Grab.Mask = "";
		Grab.NotMask = "";
		
		fstCmdsAdd("set silence 1");	// Set silence mode...	
		fstCmdsAdd("set shout 0");
		fstCmdsAdd("set kibitz 0");	
		fstCmdsAdd("set tell 0");	
		fstCmdsAdd("set chanoff 1");	
		fstCmdsAdd("set echo 1");
		fstCmdsAdd("set style 1");
		
		// what should be in text line
		fstGrabAddMask("play");
		fstGrabAddMask("blitz|standard");
		fstGrabAddMask("seeking 10|seeking 15|seeking 20");
		// what should not be
		fstGrabAddNotMask("BadUser1");
		fstGrabAddNotMask("BadUser2");
		Save_Options();
	}
	
	void fstCmdsAdd(String s) { StartCmds += s + ';'; };
	void fstGrabAddMask(String s) { Grab.Mask += s + ';'; };
	void fstGrabAddNotMask(String s) { Grab.NotMask += s + ';'; };
	
	// c-separator (;), k-counter, St-complete string to separate
	public String getNextPartBy(char c, int k, String St)
	{
		String s = null;
		for(int j=0,q=0;j<=k && q<St.length();j++)
			{
				if(j>0 && q<1) return null;
				int q2 = St.indexOf(c,q);
				s = (q2>=0 ? St.substring(q,q2) :
					(q==0? St : St.substring(q)) );
				q = (++q2);
				s=s.trim();
			}
		return s;
	}
	
	public boolean FirstTimeLoading()
	{
		//Reset_Options();
		String s = filefunc.getFileValue(FicsOpt, context() );
		if(s==null)
			{
			Set_defaults();
			return true;
			}
		return false;
	}
	
	public void Get_Options()
	{

		String s = filefunc.getFileValue(FicsOpt, context() );
		if(s!=null)
		{
			Server = ""; Port = "";
			UserLogin = ""; Password = "";
			StartCmds = "";
			Grab.Mask = ""; Grab.NotMask = "";
			
			for(String q;s.length()>0;)
			{
				int a=s.indexOf('\n');
				int b=s.indexOf('=');
				if(a>=0)
					{
					q = s.substring(0,a);
					s = s.substring(a+1);
					}
				else { q=s; s=""; }
				if(b>0)
				{
					if(q.startsWith("Server")) Server = q.substring(b+1);
					if(q.startsWith("Port")) Port = q.substring(b+1);
					if(q.startsWith("UserLogin")) UserLogin = q.substring(b+1);
					if(q.startsWith("Password")) Password = q.substring(b+1);
					if(q.startsWith("StartCmds")) StartCmds = q.substring(b+1);
					if(q.startsWith("GrabMask")) Grab.Mask = q.substring(b+1);
					if(q.startsWith("GrabNotMask")) Grab.NotMask = q.substring(b+1);
				}	
			}
		}
	}
	public void Reset_Options()
	{
		filefunc.deleteFile(FicsOpt, context() );
	}
	
	void Save_Options()
	{
		String s = "";
		s += "Server=" + Server + "\n";
		s += "Port=" + Port + "\n";
		s += "UserLogin=" + UserLogin + "\n";
		s += "Password=" + Password + "\n";
		s += "StartCmds=" + CutLastSemi(StartCmds) + "\n";
		s += "GrabMask=" + CutLastSemi(Grab.Mask) + "\n";
		s += "GrabNotMask=" + CutLastSemi(Grab.NotMask) + "\n";	
		filefunc.setFileValue(FicsOpt, s, context() );
	}
	
	String CutLastSemi(String st)
	{
		String s = st.replace('\n', ';');
		int l = s.length()-1;
		return ((s.length()>0 && s.charAt(l)==';') ? s.substring(0,l) : s);
	}
		
}	// end of class
